Package com.smartgwt.client.widgets

# Class BatchUploader

java.lang.Object
com.google.gwt.user.client.ui.UIObject
com.google.gwt.user.client.ui.Widget
com.smartgwt.client.widgets.BaseWidget
com.smartgwt.client.widgets.Canvas
com.smartgwt.client.widgets.layout.Layout
com.smartgwt.client.widgets.layout.VStack
com.smartgwt.client.widgets.BatchUploader

All Implemented Interfaces:
  `HasAttachHandlers`, `HasHandlers`, `EventListener`, `HasVisibility`, `IsWidget`, `LogicalStructure`, `HasBeforeCommitHandlers`, `HasPreviewShownHandlers`, `HasClearHandlers`, `HasClickHandlers`, `HasDoubleClickHandlers`, `HasDragMoveHandlers`, `HasDragRepositionMoveHandlers`, `HasDragRepositionStartHandlers`, `HasDragRepositionStopHandlers`, `HasDragResizeMoveHandlers`, `HasDragResizeStartHandlers`, `HasDragResizeStopHandlers`, `HasDragStartHandlers`, `HasDragStopHandlers`, `HasDropHandlers`, `HasDropMoveHandlers`, `HasDropOutHandlers`, `HasDropOverHandlers`, `HasFocusChangedHandlers`, `HasHoverHandlers`, `HasHoverHiddenHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasMouseDownHandlers`, `HasMouseMoveHandlers`, `HasMouseOutHandlers`, `HasMouseOverHandlers`, `HasMouseStillDownHandlers`, `HasMouseUpHandlers`, `HasMouseWheelHandlers`, `HasMovedHandlers`, `HasParentMovedHandlers`, `HasResizedHandlers`, `HasRightMouseDownHandlers`, `HasRuleContextChangedHandlers`, `HasScrolledHandlers`, `HasShowContextMenuHandlers`, `HasVisibilityChangedHandlers`, `HasMembersChangedHandlers`

Direct Known Subclasses:
  `BatchUploader`, `BatchUploader`

public class BatchUploader extends VStack implements HasBeforeCommitHandlers, HasPreviewShownHandlers
The BatchUploader handles the upload, validation, review and saving of a dataset expressed in CSV or other upload formats.

NOTE: BatchUploader is only available with Smart GWT Power or better.

By default, a BatchUploader consists of a single `FileItem` form field. This form field will upload a file using the special "batchUpload" built-in DataSource. The uploaded file data will be parsed and validated using the `uploadDataSource`, then streamed back to the browser, along with any errors, for display in a ListGrid.

The `BatchUploader.previewShown()` notification method will be fired when the uploaded records are being displayed in this grid.

The user can then correct any errors and submit the final dataset, which will be added to the DataSource via a series of "add" DSRequests, all submitted as a single HTTP request via `request queuing`.
Developers may specify a custom "add" operation to use on the target `uploadDataSource` via the `uploadOperation` property.

Additional form fields can be added to the form that uploads the data file via `uploadFormFields`. Values entered into these fields are not included in the "add" DSRequests used to store the uploaded records. Instead, they are stored as HttpSession attributes with the names corresponding to the names of the specified `uploadFormFields` (optionally with a `prefix` applied, in case this is necessary to avoid name collisions in the session). This allows any custom logic for the "add" operation to access these additional fields via httpSession.getAttribute(). If `uploadFormFields` are not provided method httpSession.getAttribute() will not be called.

Because all records are saved in a single HTTP request, a similar strategy of storing data as servletRequest or session attributes allows reuse of objects required to perform the "add" operations (such as field values common to all added records, or a SQL connection or transaction manager).

If you already have upload data available as a csv-formatted string or similar, the BatchUploader can be used without showing an upload interface. This can be valuable if you are picking up sample data from some custom UI (a separate upload component, or TextArea for copy/pasting content, for example).
To suppress the upload interface, set `showUploadForm` to `false` and invoke `uploadData()` directly. The `uploadData()` method passes sample data to the server as `values.pasteData`. The server side `batchUpload` dataSource has logic to extract and work with this data, exactly as if it had been directly uploaded as the content of a file.

If `uploadFieldName` is set on any of the `uploadDataSource`'s fields, the BatchUploader will use that name to map the uploaded file's content.

Note, that for `CSV data format` header line is optional. If first non-empty line in the uploaded file has no matching field names, it is assumed that there's no header row, and all rows (including the first one) are treated as data rows.

Imported data can be transformed during import, see `DataSourceField.importStrategy` for details.

A couple of server-side techniques are interesting in conjunction with the BatchUploader. One is to set the `DataSource.serverConstructor` property to point at your own class that inherits from `com.isomorphic.datasource.BasicDataSource`. The most interesting reason for doing this is to override the `validate` method and provide complete custom validation - for example, checking relations to other tables.

Another technique is to handle the initial Smart GWT call in your own servlet, by setting the `dataURL` property. You then handle the add requests with a combination of your own code and Smart GWT server API calls. This is a good way to add special pre- and post-processing to the normal server-side flow.

Note: The special "batchUpload" DataSource, which should reside in the shared/ds folder of your application's webroot (see `Installation Instructions`). is not part of your application's data flow, and it has nothing to do with the `uploadDataSource` you use to actually persist the validated and error-corrected data: it is simply a means to uploading the raw data in the first place. Normally, you should simply ignore its presence and treat it as an internal detail of the Smart GWT framework.

However, there are circumstances in which you may wish to change it to achieve specific aims. For example, you may wish to override the Java class it invokes, in order to insert your own security or other validation logic into the initial upload flow. This is entirely in keeping with the design, but we regard it as an out-of-the-ordinary use-case: normal usage is simply to ignore the presence of the batchUpload DataSource.

BatchUploader is a `VStack`, that simply stacks members on the vertical axis without trying to manage their height. If you need to control heights, you can set `vPolicy` to "fill"

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

  `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

  `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

  ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

  `DEBUG_ID_PREFIX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BatchUploader()`
  `BatchUploader(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `HandlerRegistration`
  `addBeforeCommitHandler(BeforeCommitHandler handler)`
  Add a beforeCommit handler.
  `HandlerRegistration`
  `addPreviewShownHandler(PreviewShownHandler handler)`
  Add a previewShown handler.
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `protected JavaScriptObject`
  `create()`
  `String`
  `getAllRecordsInErrorMessage()`
  Message to display when the user clicks "Commit" but there is nothing we can commit because every row in the grid has errors
  `Boolean`
  `getAutoInterpretBooleans()`
  Controls if server-side API BatchUpload.parseUploadData(...) will convert imported boolean fields values to actual Booleans or will leave them as Strings.
  `IButton`
  `getCancelButton()`
  Button that cancels the uncommitted upload.
  `String`
  `getCancelButtonTitle()`
  Title for the `cancel button`.
  `String`
  `getCancelConfirmMessage()`
  Confirmation message to show if the user clicks the "Cancel" button and `warnOnCancel` is true.
  `IButton`
  `getCommitButton()`
  Button that commits changes once the user is happy with the data.
  `String`
  `getCommitButtonTitle()`
  Title for the `commit button`.
  `String`
  `getCommitConfirmationMessage()`
  Message to display after data has been committed, when `showCommitConfirmation` is true.
  `ImportFormat`
  `getDataFormat()`
  Format to assume for user-provided data.
  `String`
  `getDataURL()`
  If set, the batchUploader will copy this value to the queue of "add" requests it sends to the server to actually populate the data.
  `String`
  `getDefaultDelimiter()`
  Deprecated.
  in favor of `uploadDelimiter`
  `String`
  `getDefaultQuoteString()`
  Deprecated.
  in favor of `uploadQuoteString`
  `String`
  `getDiscardedColumnsMessage()`
  Message displayed when columns in the imported file were discarded and `displayDiscardedColumns` is true.
  `Boolean`
  `getDisplayDiscardedColumns()`
  If columns were present in the imported data that were discarded because they could not be matched to any DataSource fields, whether these should be displayed to the user, using the `discardedColumnsMessage` shown within the `uploadStatusMessages` component.
  `String`
  `getErrorMessageDelimiterOrEndOfLine()`
  Error message to show when the uploading process detects a missing delimiter or end of line after quoted value in the first line.
  `String`
  `getErrorMessageExcelFileDetected()`
  Error message to show when the uploading process detects an Excel File, which is not supported.
  `String`
  `getErrorMessageFileIsBlank()`
  Error message to show when the uploading process detects a file with no data.
  `String`
  `getErrorMessageInputType()`
  Error message to show when the uploading process detects an invalid inputType.
  `String`
  `getErrorMessageRowsNotParsed()`
  Error message to show when the uploaded file has rows other than the first row that could not be parsed.
  `String`
  `getErrorMessageUndeterminedDelimiter()`
  Error message to show when the uploading process is unable to detect the delimiter.
  `String`
  `getErrorMessageUnterminatedQuote()`
  Error message to show when the uploading process detects an unterminated quote string in the first line.
  `ListGrid`
  `getGrid()`
  Grid which will show a preview of data to be uploaded, with errors flagged
  `ListGridField[]`
  `getGridFields()`
  Fields to apply to `grid`.
  `LogicalStructureObject`
  `getLogicalStructure()`
  Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `IButton`
  `getNextButton()`
  Button that scrolls grid to the next error.
  `String`
  `getNextButtonTitle()`
  Title for the `next error button`.
  `static BatchUploader`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `PartialCommitOption`
  `getPartialCommit()`
  Specifies what action to take if the user attempts to commit a partially validated set of data (ie, one that still contains some errors).
  `String`
  `getPartialCommitConfirmationMessage()`
  Message to display after data has been committed, when `showCommitConfirmation` is true.
  `String`
  `getPartialCommitError()`
  If `partialCommit` is set to "prevent", the text to display to the user if they try to commit a dataset containing errors.
  `String`
  `getPartialCommitPrompt()`
  If `partialCommit` is set to "prompt", the text to display to the user in the confirmation dialog.
  `IButton`
  `getPreviousButton()`
  Button that scrolls grid to the previous error.
  `String`
  `getPreviousButtonTitle()`
  Title for the `previous error button`.
  `DSRequest`
  `getRequestProperties()`
  Object containing properties to send with every "add" request this batchUploader sends.
  `Boolean`
  `getShowCommitConfirmation()`
  Whether to show the `commit message` after data is successfully committed.
  `Boolean`
  `getShowUploadForm()`
  Should the `uploadForm` be displayed.
  `String`
  `getUpdatesRolledBackMessage()`
  Message to display if at least one update was rolled back due to errors in another row.
  `IButton`
  `getUploadButton()`
  Button that triggers the upload.
  `String`
  `getUploadButtonTitle()`
  Title for the `upload button`.
  `DataSource`
  `getUploadDataSource()`
  DataSource used to save uploaded records.
  `String`
  `getUploadDelimiter()`
  The delimiter to use when importing character-delimited files.
  `String`
  `getUploadEncoding()`
  On server-side, BatchUploader uses `DataImport` to import uploaded files, specifically APIs taking `java.io.Reader` parameter.
  `String`
  `getUploadFieldPrefix()`
  String to prepend to the names of the additional fields specified in `uploadFormFields` before they are stored in the HttpSession on the server.
  `FileItem`
  `getUploadFileItem()`
  FileItem for selecting the file to upload.
  `String`
  `getUploadFileLabel()`
  Title to display next to the `FileItem` field where the user enters a filename to upload
  `DynamicForm`
  `getUploadForm()`
  Form used to specify file to upload, and any additional fields required.
  `FormItem[]`
  `getUploadFormFields()`
  Optional fields for the uploadForm.
  `String`
  `getUploadOperation()`
  Optional `DSRequest.operationId` for the "add" operation used to add new records to the `uploadDataSource`.
  `String`
  `getUploadQuoteString()`
  The character used to quote strings.
  `HTMLFlow`
  `getUploadStatusMessages()`
  Container for informational messages that are shown when a user attempts an upload.
  `Boolean`
  `getWarnOnCancel()`
  If set, indicates that a warning dialog should be shown when Cancel is clicked, asking the user to confirm that this is really what they want to do.
  `BatchUploader`
  `setAllRecordsInErrorMessage(String allRecordsInErrorMessage)`
  Message to display when the user clicks "Commit" but there is nothing we can commit because every row in the grid has errors
  `BatchUploader`
  `setAutoInterpretBooleans(Boolean autoInterpretBooleans)`
  Controls if server-side API BatchUpload.parseUploadData(...) will convert imported boolean fields values to actual Booleans or will leave them as Strings.
  `BatchUploader`
  `setCancelButtonTitle(String cancelButtonTitle)`
  Title for the `cancel button`.
  `BatchUploader`
  `setCancelConfirmMessage(String cancelConfirmMessage)`
  Confirmation message to show if the user clicks the "Cancel" button and `warnOnCancel` is true.
  `BatchUploader`
  `setCommitButtonTitle(String commitButtonTitle)`
  Title for the `commit button`.
  `BatchUploader`
  `setCommitConfirmationMessage(String commitConfirmationMessage)`
  Message to display after data has been committed, when `showCommitConfirmation` is true.
  `BatchUploader`
  `setDataFormat(ImportFormat dataFormat)`
  Format to assume for user-provided data.
  `BatchUploader`
  `setDataURL(String dataURL)`
  If set, the batchUploader will copy this value to the queue of "add" requests it sends to the server to actually populate the data.
  `BatchUploader`
  `setDefaultDelimiter(String defaultDelimiter)`
  Deprecated.
  in favor of `uploadDelimiter`
  `static void`
  `setDefaultProperties(BatchUploader batchUploaderProperties)`
  Class level method to set the default properties of this class.
  `BatchUploader`
  `setDefaultQuoteString(String defaultQuoteString)`
  Deprecated.
  in favor of `uploadQuoteString`
  `BatchUploader`
  `setDiscardedColumnsMessage(String discardedColumnsMessage)`
  Message displayed when columns in the imported file were discarded and `displayDiscardedColumns` is true.
  `BatchUploader`
  `setDisplayDiscardedColumns(Boolean displayDiscardedColumns)`
  If columns were present in the imported data that were discarded because they could not be matched to any DataSource fields, whether these should be displayed to the user, using the `discardedColumnsMessage` shown within the `uploadStatusMessages` component.
  `BatchUploader`
  `setErrorMessageDelimiterOrEndOfLine(String errorMessageDelimiterOrEndOfLine)`
  Error message to show when the uploading process detects a missing delimiter or end of line after quoted value in the first line.
  `BatchUploader`
  `setErrorMessageExcelFileDetected(String errorMessageExcelFileDetected)`
  Error message to show when the uploading process detects an Excel File, which is not supported.
  `BatchUploader`
  `setErrorMessageFileIsBlank(String errorMessageFileIsBlank)`
  Error message to show when the uploading process detects a file with no data.
  `BatchUploader`
  `setErrorMessageInputType(String errorMessageInputType)`
  Error message to show when the uploading process detects an invalid inputType.
  `BatchUploader`
  `setErrorMessageRowsNotParsed(String errorMessageRowsNotParsed)`
  Error message to show when the uploaded file has rows other than the first row that could not be parsed.
  `BatchUploader`
  `setErrorMessageUndeterminedDelimiter(String errorMessageUndeterminedDelimiter)`
  Error message to show when the uploading process is unable to detect the delimiter.
  `BatchUploader`
  `setErrorMessageUnterminatedQuote(String errorMessageUnterminatedQuote)`
  Error message to show when the uploading process detects an unterminated quote string in the first line.
  `BatchUploader`
  `setGridFields(ListGridField... gridFields)`
  Fields to apply to `grid`.
  `LogicalStructureObject`
  `setLogicalStructure(BatchUploaderLogicalStructure s)`
  Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `BatchUploader`
  `setNextButtonTitle(String nextButtonTitle)`
  Title for the `next error button`.
  `BatchUploader`
  `setPartialCommit(PartialCommitOption partialCommit)`
  Specifies what action to take if the user attempts to commit a partially validated set of data (ie, one that still contains some errors).
  `BatchUploader`
  `setPartialCommitConfirmationMessage(String partialCommitConfirmationMessage)`
  Message to display after data has been committed, when `showCommitConfirmation` is true.
  `BatchUploader`
  `setPartialCommitError(String partialCommitError)`
  If `partialCommit` is set to "prevent", the text to display to the user if they try to commit a dataset containing errors.
  `BatchUploader`
  `setPartialCommitPrompt(String partialCommitPrompt)`
  If `partialCommit` is set to "prompt", the text to display to the user in the confirmation dialog.
  `BatchUploader`
  `setPreviousButtonTitle(String previousButtonTitle)`
  Title for the `previous error button`.
  `BatchUploader`
  `setRequestProperties(DSRequest requestProperties)`
  Object containing properties to send with every "add" request this batchUploader sends.
  `BatchUploader`
  `setShowCommitConfirmation(Boolean showCommitConfirmation)`
  Whether to show the `commit message` after data is successfully committed.
  `BatchUploader`
  `setShowUploadForm(Boolean showUploadForm)`
  Should the `uploadForm` be displayed.
  `BatchUploader`
  `setUpdatesRolledBackMessage(String updatesRolledBackMessage)`
  Message to display if at least one update was rolled back due to errors in another row.
  `BatchUploader`
  `setUploadButtonTitle(String uploadButtonTitle)`
  Title for the `upload button`.
  `BatchUploader`
  `setUploadDataSource(DataSource uploadDataSource)`
  DataSource used to save uploaded records.
  `BatchUploader`
  `setUploadDelimiter(String uploadDelimiter)`
  The delimiter to use when importing character-delimited files.
  `BatchUploader`
  `setUploadEncoding(String uploadEncoding)`
  On server-side, BatchUploader uses `DataImport` to import uploaded files, specifically APIs taking `java.io.Reader` parameter.
  `BatchUploader`
  `setUploadFieldPrefix(String uploadFieldPrefix)`
  String to prepend to the names of the additional fields specified in `uploadFormFields` before they are stored in the HttpSession on the server.
  `BatchUploader`
  `setUploadFileLabel(String uploadFileLabel)`
  Title to display next to the `FileItem` field where the user enters a filename to upload
  `BatchUploader`
  `setUploadFormFields(FormItem... uploadFormFields)`
  Optional fields for the uploadForm.
  `void`
  `setUploadFormItems(FormItem... items)`
  Synonym of `setUploadFormFields(FormItem...)`.
  `BatchUploader`
  `setUploadOperation(String uploadOperation)`
  Optional `DSRequest.operationId` for the "add" operation used to add new records to the `uploadDataSource`.
  `BatchUploader`
  `setUploadQuoteString(String uploadQuoteString)`
  The character used to quote strings.
  `BatchUploader`
  `setWarnOnCancel(Boolean warnOnCancel)`
  If set, indicates that a warning dialog should be shown when Cancel is clicked, asking the user to confirm that this is really what they want to do.
  `void`
  `uploadData(String data)`
  This method assumes a developer has sample data in memory (for example a csv-formatted string), and invokes the dataSource upload operation directly, bypassing the uploadForm.

  ### Methods inherited from class com.smartgwt.client.widgets.layout.VStack

  `setDefaultProperties, setLogicalStructure`

  ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

  `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEditProxyConstructor, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersAsStringArray, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, replaceMember, revealChild, revealChild, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEditProxyConstructor, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

  ### Methods inherited from class com.smartgwt.client.widgets.Canvas

  `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, dataContextChanged, deparent, depeer, disable, doValueDictation, doVoiceCommand, enable, encloses, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAllCanvases, getAllCanvases, getAllCanvases, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAriaRole, getAriaStateDefaults, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanDropContent, getCanDropFiles, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenAsStringArray, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCorrectZoomOverflow, getCursor, getDataContext, getDataPath, getDefaultHeight, getDefaultWidth, getDeferActionConversion, getDefiningProperty, getDefiningPropertyName, getDefiningPropertyNameOptions, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getEvents, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverScreen, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentCanvasAsString, getParentElement, getParentElementAsString, getPeers, getPendingMarkerStyle, getPendingMarkerVisible, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowFocusOutline, getShowHover, getShowHoverComponents, getShowPointer, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSingleDiv, getSizeMayChangeOnRedraw, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getStyleName, getTabIndex, getTestDataContext, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getTopLevelComponents, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDragMask, getUseGeneratedStyles, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getWorkflows, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, initComplete, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanDropContent, setCanDropFiles, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataPath, setDefaultHeight, setDefaultNativeAutoHideScrollbars, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDefaultWidth, setDeferActionConversion, setDefiningProperty, setDefiningPropertyNameOptions, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverScreen, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentCanvas, setParentElement, setParentElement, setPeers, setPendingMarkerStyle, setPendingMarkerVisible, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowFocusOutline, setShowHover, setShowHoverComponents, setShowPointer, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSingleDiv, setSizeMayChangeOnRedraw, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setStyleName, setTabIndex, setTestDataContext, setTitle, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDragMask, setUseGeneratedStyles, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setWorkflows, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPendingMarker, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, startDebuggingOverflow, stopDebuggingOverflow, supportsValueDictation, supportsVoiceCommands, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

  ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

  `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAutoDraw, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoDraw, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

  ### Methods inherited from class com.google.gwt.user.client.ui.Widget

  `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

  ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

  `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### BatchUploader

    public BatchUploader()

  - ### BatchUploader

    public BatchUploader(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static BatchUploader getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### create

    protected JavaScriptObject create()
    Overrides:
      `create` in class `VStack`

  - ### setAllRecordsInErrorMessage

    public BatchUploader setAllRecordsInErrorMessage(String allRecordsInErrorMessage) throws IllegalStateException
    Message to display when the user clicks "Commit" but there is nothing we can commit because every row in the grid has errors
    Parameters:
      `allRecordsInErrorMessage` - New allRecordsInErrorMessage value. Default value is "All records have errors; nothing to commit"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getAllRecordsInErrorMessage

    public String getAllRecordsInErrorMessage()
    Message to display when the user clicks "Commit" but there is nothing we can commit because every row in the grid has errors
    Returns:
      Current allRecordsInErrorMessage value. Default value is "All records have errors; nothing to commit"

  - ### setAutoInterpretBooleans

    public BatchUploader setAutoInterpretBooleans(Boolean autoInterpretBooleans)
    Controls if server-side API BatchUpload.parseUploadData(...) will convert imported boolean fields values to actual Booleans or will leave them as Strings. The default is true.

    Default behavior would interpret boolean values by following rules:

    - Accept all caps permutations of "true"/"false", "yes"/"no", and "null"
    - "T" == true, "F" == false
    - "Y" == true, "N" == false
    - "0" is false
    - empty string is null
    - everything else is true
    Parameters:
      `autoInterpretBooleans` - New autoInterpretBooleans value. Default value is true
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getAutoInterpretBooleans

    public Boolean getAutoInterpretBooleans()
    Controls if server-side API BatchUpload.parseUploadData(...) will convert imported boolean fields values to actual Booleans or will leave them as Strings. The default is true.

    Default behavior would interpret boolean values by following rules:

    - Accept all caps permutations of "true"/"false", "yes"/"no", and "null"
    - "T" == true, "F" == false
    - "Y" == true, "N" == false
    - "0" is false
    - empty string is null
    - everything else is true
    Returns:
      Current autoInterpretBooleans value. Default value is true

  - ### getCancelButton

    public IButton getCancelButton() throws IllegalStateException
    Button that cancels the uncommitted upload.

    This component is an AutoChild named "cancelButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current cancelButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setCancelButtonTitle

    public BatchUploader setCancelButtonTitle(String cancelButtonTitle) throws IllegalStateException
    Title for the `cancel button`.
    Parameters:
      `cancelButtonTitle` - New cancelButtonTitle value. Default value is "Cancel"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCancelButtonTitle

    public String getCancelButtonTitle()
    Title for the `cancel button`.
    Returns:
      Current cancelButtonTitle value. Default value is "Cancel"

  - ### setCancelConfirmMessage

    public BatchUploader setCancelConfirmMessage(String cancelConfirmMessage)
    Confirmation message to show if the user clicks the "Cancel" button and `warnOnCancel` is true. Defaults to "You will lose any work you have done on this data. Proceed anyway?"
    Parameters:
      `cancelConfirmMessage` - New cancelConfirmMessage value. Default value is See below
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getCancelConfirmMessage

    public String getCancelConfirmMessage()
    Confirmation message to show if the user clicks the "Cancel" button and `warnOnCancel` is true. Defaults to "You will lose any work you have done on this data. Proceed anyway?"
    Returns:
      Current cancelConfirmMessage value. Default value is See below

  - ### getCommitButton

    public IButton getCommitButton() throws IllegalStateException
    Button that commits changes once the user is happy with the data.

    This component is an AutoChild named "commitButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current commitButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setCommitButtonTitle

    public BatchUploader setCommitButtonTitle(String commitButtonTitle) throws IllegalStateException
    Title for the `commit button`.
    Parameters:
      `commitButtonTitle` - New commitButtonTitle value. Default value is "Commit"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCommitButtonTitle

    public String getCommitButtonTitle()
    Title for the `commit button`.
    Returns:
      Current commitButtonTitle value. Default value is "Commit"

  - ### setCommitConfirmationMessage

    public BatchUploader setCommitConfirmationMessage(String commitConfirmationMessage) throws IllegalStateException
    Message to display after data has been committed, when `showCommitConfirmation` is true.
    Parameters:
      `commitConfirmationMessage` - New commitConfirmationMessage value. Default value is "Records added"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCommitConfirmationMessage

    public String getCommitConfirmationMessage()
    Message to display after data has been committed, when `showCommitConfirmation` is true.
    Returns:
      Current commitConfirmationMessage value. Default value is "Records added"

  - ### setDataFormat

    public BatchUploader setDataFormat(ImportFormat dataFormat) throws IllegalStateException
    Format to assume for user-provided data. Use `ImportFormat` "auto" for auto-detection.
    Parameters:
      `dataFormat` - New dataFormat value. Default value is "csv"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getDataFormat

    public ImportFormat getDataFormat()
    Format to assume for user-provided data. Use `ImportFormat` "auto" for auto-detection.
    Returns:
      Current dataFormat value. Default value is "csv"

  - ### setDataURL

    public BatchUploader setDataURL(String dataURL)
    If set, the batchUploader will copy this value to the queue of "add" requests it sends to the server to actually populate the data. You can use this facility to route the queue to your own server-side logic, for example to add pre- or post-processing.
    Parameters:
      `dataURL` - New dataURL value. Default value is null
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getDataURL

    public String getDataURL()
    If set, the batchUploader will copy this value to the queue of "add" requests it sends to the server to actually populate the data. You can use this facility to route the queue to your own server-side logic, for example to add pre- or post-processing.
    Returns:
      Current dataURL value. Default value is null

  - ### setDefaultDelimiter

    public BatchUploader setDefaultDelimiter(String defaultDelimiter)
    Deprecated.
    in favor of `uploadDelimiter`
    The delimiter to use when importing character-delimited files. The default is comma (CSV).
    Parameters:
      `defaultDelimiter` - New defaultDelimiter value. Default value is ","
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getDefaultDelimiter

    public String getDefaultDelimiter()
    Deprecated.
    in favor of `uploadDelimiter`
    The delimiter to use when importing character-delimited files. The default is comma (CSV).
    Returns:
      Current defaultDelimiter value. Default value is ","

  - ### setDefaultQuoteString

    public BatchUploader setDefaultQuoteString(String defaultQuoteString)
    Deprecated.
    in favor of `uploadQuoteString`
    The default character used to quote strings.
    Parameters:
      `defaultQuoteString` - New defaultQuoteString value. Default value is "\""
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getDefaultQuoteString

    public String getDefaultQuoteString()
    Deprecated.
    in favor of `uploadQuoteString`
    The default character used to quote strings.
    Returns:
      Current defaultQuoteString value. Default value is "\""

  - ### setDiscardedColumnsMessage

    public BatchUploader setDiscardedColumnsMessage(String discardedColumnsMessage) throws IllegalStateException
    Message displayed when columns in the imported file were discarded and `displayDiscardedColumns` is true. Within this message, ${discardedColumns} can be used to show a comma separated list of the column names that were discarded (example: "price, saleDate, total").

    Default message is: "The following columns in your uploaded file were ignored because they did not match any of the expected column names: ${discardedColumns}"

    Parameters:
      `discardedColumnsMessage` - New discardedColumnsMessage value. Default value is "..."
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getDiscardedColumnsMessage

    public String getDiscardedColumnsMessage()
    Message displayed when columns in the imported file were discarded and `displayDiscardedColumns` is true. Within this message, ${discardedColumns} can be used to show a comma separated list of the column names that were discarded (example: "price, saleDate, total").

    Default message is: "The following columns in your uploaded file were ignored because they did not match any of the expected column names: ${discardedColumns}"

    Returns:
      Current discardedColumnsMessage value. Default value is "..."

  - ### setDisplayDiscardedColumns

    public BatchUploader setDisplayDiscardedColumns(Boolean displayDiscardedColumns) throws IllegalStateException
    If columns were present in the imported data that were discarded because they could not be matched to any DataSource fields, whether these should be displayed to the user, using the `discardedColumnsMessage` shown within the `uploadStatusMessages` component.
    Parameters:
      `displayDiscardedColumns` - New displayDiscardedColumns value. Default value is true
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getDisplayDiscardedColumns

    public Boolean getDisplayDiscardedColumns()
    If columns were present in the imported data that were discarded because they could not be matched to any DataSource fields, whether these should be displayed to the user, using the `discardedColumnsMessage` shown within the `uploadStatusMessages` component.
    Returns:
      Current displayDiscardedColumns value. Default value is true

  - ### setErrorMessageDelimiterOrEndOfLine

    public BatchUploader setErrorMessageDelimiterOrEndOfLine(String errorMessageDelimiterOrEndOfLine) throws IllegalStateException
    Error message to show when the uploading process detects a missing delimiter or end of line after quoted value in the first line.
    Parameters:
      `errorMessageDelimiterOrEndOfLine` - New errorMessageDelimiterOrEndOfLine value. Default value is "Delimiter or end of line expected after quoted value - problem found in the first line at character position: ${errorOffset}."
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getErrorMessageDelimiterOrEndOfLine

    public String getErrorMessageDelimiterOrEndOfLine()
    Error message to show when the uploading process detects a missing delimiter or end of line after quoted value in the first line.
    Returns:
      Current errorMessageDelimiterOrEndOfLine value. Default value is "Delimiter or end of line expected after quoted value - problem found in the first line at character position: ${errorOffset}."

  - ### setErrorMessageExcelFileDetected

    public BatchUploader setErrorMessageExcelFileDetected(String errorMessageExcelFileDetected) throws IllegalStateException
    Error message to show when the uploading process detects an Excel File, which is not supported.
    Parameters:
      `errorMessageExcelFileDetected` - New errorMessageExcelFileDetected value. Default value is "You uploaded an Excel file. Please save your data as a csv file and re-upload"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getErrorMessageExcelFileDetected

    public String getErrorMessageExcelFileDetected()
    Error message to show when the uploading process detects an Excel File, which is not supported.
    Returns:
      Current errorMessageExcelFileDetected value. Default value is "You uploaded an Excel file. Please save your data as a csv file and re-upload"

  - ### setErrorMessageFileIsBlank

    public BatchUploader setErrorMessageFileIsBlank(String errorMessageFileIsBlank) throws IllegalStateException
    Error message to show when the uploading process detects a file with no data.
    Parameters:
      `errorMessageFileIsBlank` - New errorMessageFileIsBlank value. Default value is "The provided file is blank. Please, provide a file with data."
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getErrorMessageFileIsBlank

    public String getErrorMessageFileIsBlank()
    Error message to show when the uploading process detects a file with no data.
    Returns:
      Current errorMessageFileIsBlank value. Default value is "The provided file is blank. Please, provide a file with data."

  - ### setErrorMessageInputType

    public BatchUploader setErrorMessageInputType(String errorMessageInputType) throws IllegalStateException
    Error message to show when the uploading process detects an invalid inputType.
    Parameters:
      `errorMessageInputType` - New errorMessageInputType value. Default value is "Invalid inputType value was set!"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getErrorMessageInputType

    public String getErrorMessageInputType()
    Error message to show when the uploading process detects an invalid inputType.
    Returns:
      Current errorMessageInputType value. Default value is "Invalid inputType value was set!"

  - ### setErrorMessageRowsNotParsed

    public BatchUploader setErrorMessageRowsNotParsed(String errorMessageRowsNotParsed) throws IllegalStateException
    Error message to show when the uploaded file has rows other than the first row that could not be parsed.

    This is a dynamic string - text within `${...}` will be evaluated as JS code when the message is displayed.

    The following variables are available to be used in this message:

    - goodRowCount: Total rows that were parsed correctly.
    - totalRows: Total rows to be parsed in the uploaded file.
    - firstBadRow: First row that could not be parsed.
    - badRowCount: Total rows that could not be parsed.
    Parameters:
      `errorMessageRowsNotParsed` - New errorMessageRowsNotParsed value. Default value is "Some rows could not be parsed; the grid below shows ${goodRowCount} of ${totalRows} data rows. Row number ${firstBadRow} was the first row to fail to be parsed."
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getErrorMessageRowsNotParsed

    public String getErrorMessageRowsNotParsed()
    Error message to show when the uploaded file has rows other than the first row that could not be parsed.

    This is a dynamic string - text within `${...}` will be evaluated as JS code when the message is displayed.

    The following variables are available to be used in this message:

    - goodRowCount: Total rows that were parsed correctly.
    - totalRows: Total rows to be parsed in the uploaded file.
    - firstBadRow: First row that could not be parsed.
    - badRowCount: Total rows that could not be parsed.
    Returns:
      Current errorMessageRowsNotParsed value. Default value is "Some rows could not be parsed; the grid below shows ${goodRowCount} of ${totalRows} data rows. Row number ${firstBadRow} was the first row to fail to be parsed."

  - ### setErrorMessageUndeterminedDelimiter

    public BatchUploader setErrorMessageUndeterminedDelimiter(String errorMessageUndeterminedDelimiter) throws IllegalStateException
    Error message to show when the uploading process is unable to detect the delimiter.
    Parameters:
      `errorMessageUndeterminedDelimiter` - New errorMessageUndeterminedDelimiter value. Default value is "We were unable to guess the delimiter"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getErrorMessageUndeterminedDelimiter

    public String getErrorMessageUndeterminedDelimiter()
    Error message to show when the uploading process is unable to detect the delimiter.
    Returns:
      Current errorMessageUndeterminedDelimiter value. Default value is "We were unable to guess the delimiter"

  - ### setErrorMessageUnterminatedQuote

    public BatchUploader setErrorMessageUnterminatedQuote(String errorMessageUnterminatedQuote) throws IllegalStateException
    Error message to show when the uploading process detects an unterminated quote string in the first line.
    Parameters:
      `errorMessageUnterminatedQuote` - New errorMessageUnterminatedQuote value. Default value is "Unterminated quote string - problem found in the first line at character position: ${errorOffset}."
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getErrorMessageUnterminatedQuote

    public String getErrorMessageUnterminatedQuote()
    Error message to show when the uploading process detects an unterminated quote string in the first line.
    Returns:
      Current errorMessageUnterminatedQuote value. Default value is "Unterminated quote string - problem found in the first line at character position: ${errorOffset}."

  - ### getGrid

    public ListGrid getGrid() throws IllegalStateException
    Grid which will show a preview of data to be uploaded, with errors flagged

    This component is an AutoChild named "grid". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current grid value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setGridFields

    public BatchUploader setGridFields(ListGridField... gridFields)
    Fields to apply to `grid`. These will override the field definitions in the `uploadDataSource` on a field by field basis, as described under `DataBoundComponent.fields`.
    Parameters:
      `gridFields` - New gridFields value. Default value is null
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getGridFields

    public ListGridField[] getGridFields()
    Fields to apply to `grid`. These will override the field definitions in the `uploadDataSource` on a field by field basis, as described under `DataBoundComponent.fields`.
    Returns:
      Current gridFields value. Default value is null

  - ### getNextButton

    public IButton getNextButton() throws IllegalStateException
    Button that scrolls grid to the next error.

    This component is an AutoChild named "nextButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current nextButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setNextButtonTitle

    public BatchUploader setNextButtonTitle(String nextButtonTitle) throws IllegalStateException
    Title for the `next error button`.
    Parameters:
      `nextButtonTitle` - New nextButtonTitle value. Default value is "Next error"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getNextButtonTitle

    public String getNextButtonTitle()
    Title for the `next error button`.
    Returns:
      Current nextButtonTitle value. Default value is "Next error"

  - ### setPartialCommit

    public BatchUploader setPartialCommit(PartialCommitOption partialCommit)
    Specifies what action to take if the user attempts to commit a partially validated set of data (ie, one that still contains some errors).
    Parameters:
      `partialCommit` - New partialCommit value. Default value is "prompt"
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getPartialCommit

    public PartialCommitOption getPartialCommit()
    Specifies what action to take if the user attempts to commit a partially validated set of data (ie, one that still contains some errors).
    Returns:
      Current partialCommit value. Default value is "prompt"

  - ### setPartialCommitConfirmationMessage

    public BatchUploader setPartialCommitConfirmationMessage(String partialCommitConfirmationMessage) throws IllegalStateException
    Message to display after data has been committed, when `showCommitConfirmation` is true.
    Parameters:
      `partialCommitConfirmationMessage` - New partialCommitConfirmationMessage value. Default value is "Valid records added; some records remain in error"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getPartialCommitConfirmationMessage

    public String getPartialCommitConfirmationMessage()
    Message to display after data has been committed, when `showCommitConfirmation` is true.
    Returns:
      Current partialCommitConfirmationMessage value. Default value is "Valid records added; some records remain in error"

  - ### setPartialCommitError

    public BatchUploader setPartialCommitError(String partialCommitError)
    If `partialCommit` is set to "prevent", the text to display to the user if they try to commit a dataset containing errors. By default, this text is "There are errors in your data. Please correct all errors before clicking Commit"
    Parameters:
      `partialCommitError` - New partialCommitError value. Default value is See below
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getPartialCommitError

    public String getPartialCommitError()
    If `partialCommit` is set to "prevent", the text to display to the user if they try to commit a dataset containing errors. By default, this text is "There are errors in your data. Please correct all errors before clicking Commit"
    Returns:
      Current partialCommitError value. Default value is See below

  - ### setPartialCommitPrompt

    public BatchUploader setPartialCommitPrompt(String partialCommitPrompt)
    If `partialCommit` is set to "prompt", the text to display to the user in the confirmation dialog. By default, this text is "There are errors in your data so it cannot all be saved. If you proceed, you will lose the records with errors. Click 'OK' to proceed anyway, or 'Cancel' to return to your data"
    Parameters:
      `partialCommitPrompt` - New partialCommitPrompt value. Default value is See below
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getPartialCommitPrompt

    public String getPartialCommitPrompt()
    If `partialCommit` is set to "prompt", the text to display to the user in the confirmation dialog. By default, this text is "There are errors in your data so it cannot all be saved. If you proceed, you will lose the records with errors. Click 'OK' to proceed anyway, or 'Cancel' to return to your data"
    Returns:
      Current partialCommitPrompt value. Default value is See below

  - ### getPreviousButton

    public IButton getPreviousButton() throws IllegalStateException
    Button that scrolls grid to the previous error.

    This component is an AutoChild named "previousButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current previousButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setPreviousButtonTitle

    public BatchUploader setPreviousButtonTitle(String previousButtonTitle) throws IllegalStateException
    Title for the `previous error button`.
    Parameters:
      `previousButtonTitle` - New previousButtonTitle value. Default value is "Previous error"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getPreviousButtonTitle

    public String getPreviousButtonTitle()
    Title for the `previous error button`.
    Returns:
      Current previousButtonTitle value. Default value is "Previous error"

  - ### setRequestProperties

    public BatchUploader setRequestProperties(DSRequest requestProperties)
    Object containing properties to send with every "add" request this batchUploader sends.
    Parameters:
      `requestProperties` - New requestProperties value. Default value is null
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getRequestProperties

    public DSRequest getRequestProperties()
    Object containing properties to send with every "add" request this batchUploader sends.
    Returns:
      Current requestProperties value. Default value is null

  - ### setShowCommitConfirmation

    public BatchUploader setShowCommitConfirmation(Boolean showCommitConfirmation) throws IllegalStateException
    Whether to show the `commit message` after data is successfully committed.
    Parameters:
      `showCommitConfirmation` - New showCommitConfirmation value. Default value is true
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getShowCommitConfirmation

    public Boolean getShowCommitConfirmation()
    Whether to show the `commit message` after data is successfully committed.
    Returns:
      Current showCommitConfirmation value. Default value is true

  - ### setShowUploadForm

    public BatchUploader setShowUploadForm(Boolean showUploadForm) throws IllegalStateException
    Should the `uploadForm` be displayed.

    Setting this value to false will suppress the default upload interface for the BatchUploader. In this case sample data may be uploaded directly via the `uploadData()` method.

    Note : This is an advanced setting

    Parameters:
      `showUploadForm` - New showUploadForm value. Default value is true
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getShowUploadForm

    public Boolean getShowUploadForm()
    Should the `uploadForm` be displayed.

    Setting this value to false will suppress the default upload interface for the BatchUploader. In this case sample data may be uploaded directly via the `uploadData()` method.

    Returns:
      Current showUploadForm value. Default value is true

  - ### setUpdatesRolledBackMessage

    public BatchUploader setUpdatesRolledBackMessage(String updatesRolledBackMessage) throws IllegalStateException
    Message to display if at least one update was rolled back due to errors in another row. See the `transactions overview` for details of Smart GWT's automatic transactional updates feature
    Parameters:
      `updatesRolledBackMessage` - New updatesRolledBackMessage value. Default value is "One or more updates were rolled-back due to errors on other rows"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getUpdatesRolledBackMessage

    public String getUpdatesRolledBackMessage()
    Message to display if at least one update was rolled back due to errors in another row. See the `transactions overview` for details of Smart GWT's automatic transactional updates feature
    Returns:
      Current updatesRolledBackMessage value. Default value is "One or more updates were rolled-back due to errors on other rows"

  - ### getUploadButton

    public IButton getUploadButton() throws IllegalStateException
    Button that triggers the upload.

    This component is an AutoChild named "uploadButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current uploadButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setUploadButtonTitle

    public BatchUploader setUploadButtonTitle(String uploadButtonTitle) throws IllegalStateException
    Title for the `upload button`.
    Parameters:
      `uploadButtonTitle` - New uploadButtonTitle value. Default value is "Upload"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getUploadButtonTitle

    public String getUploadButtonTitle()
    Title for the `upload button`.
    Returns:
      Current uploadButtonTitle value. Default value is "Upload"

  - ### setUploadDataSource

    public BatchUploader setUploadDataSource(DataSource uploadDataSource) throws IllegalStateException
    DataSource used to save uploaded records. Should have an operation of type "add".

    Be careful to note that this is the DataSource representing your data as it will be persisted to your server. It is completely different from the special "batchUpload" DataSource which is used purely as a medium to upload the raw data to the server in the first place.

    Parameters:
      `uploadDataSource` - New uploadDataSource value. Default value is null
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getUploadDataSource

    public DataSource getUploadDataSource()
    DataSource used to save uploaded records. Should have an operation of type "add".

    Be careful to note that this is the DataSource representing your data as it will be persisted to your server. It is completely different from the special "batchUpload" DataSource which is used purely as a medium to upload the raw data to the server in the first place.

    Returns:
      Current uploadDataSource value. Default value is null

  - ### setUploadDelimiter

    public BatchUploader setUploadDelimiter(String uploadDelimiter)
    The delimiter to use when importing character-delimited files. The default is comma (CSV).
    Parameters:
      `uploadDelimiter` - New uploadDelimiter value. Default value is ","
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getUploadDelimiter

    public String getUploadDelimiter()
    The delimiter to use when importing character-delimited files. The default is comma (CSV).
    Returns:
      Current uploadDelimiter value. Default value is ","

  - ### setUploadEncoding

    public BatchUploader setUploadEncoding(String uploadEncoding)
    On server-side, BatchUploader uses `DataImport` to import uploaded files, specifically APIs taking `java.io.Reader` parameter. `BatchUploader.uploadEncoding` setting defines the encoding, which will be used to create a `java.io.Reader` instance to read data from uploaded files. The default is "UTF-8".
    Parameters:
      `uploadEncoding` - New uploadEncoding value. Default value is "UTF-8"
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getUploadEncoding

    public String getUploadEncoding()
    On server-side, BatchUploader uses `DataImport` to import uploaded files, specifically APIs taking `java.io.Reader` parameter. `BatchUploader.uploadEncoding` setting defines the encoding, which will be used to create a `java.io.Reader` instance to read data from uploaded files. The default is "UTF-8".
    Returns:
      Current uploadEncoding value. Default value is "UTF-8"

  - ### setUploadFieldPrefix

    public BatchUploader setUploadFieldPrefix(String uploadFieldPrefix)
    String to prepend to the names of the additional fields specified in `uploadFormFields` before they are stored in the HttpSession on the server. This property provides a basic namespace facility, allowing you to avoid name collisions with existing session attributes.

    Example usage: if you have an additional field called "someDate" and you set uploadFieldPrefix to "myFields_", your additionalFormField will be available as an HttpSession attribute called "myFields_someDate"

    Parameters:
      `uploadFieldPrefix` - New uploadFieldPrefix value. Default value is null
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getUploadFieldPrefix

    public String getUploadFieldPrefix()
    String to prepend to the names of the additional fields specified in `uploadFormFields` before they are stored in the HttpSession on the server. This property provides a basic namespace facility, allowing you to avoid name collisions with existing session attributes.

    Example usage: if you have an additional field called "someDate" and you set uploadFieldPrefix to "myFields_", your additionalFormField will be available as an HttpSession attribute called "myFields_someDate"

    Returns:
      Current uploadFieldPrefix value. Default value is null

  - ### getUploadFileItem

    public FileItem getUploadFileItem() throws IllegalStateException
    FileItem for selecting the file to upload.

    This component is an AutoChild named "uploadFileItem". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current uploadFileItem value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setUploadFileLabel

    public BatchUploader setUploadFileLabel(String uploadFileLabel) throws IllegalStateException
    Title to display next to the `FileItem` field where the user enters a filename to upload
    Parameters:
      `uploadFileLabel` - New uploadFileLabel value. Default value is "Upload File"
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getUploadFileLabel

    public String getUploadFileLabel()
    Title to display next to the `FileItem` field where the user enters a filename to upload
    Returns:
      Current uploadFileLabel value. Default value is "Upload File"

  - ### getUploadForm

    public DynamicForm getUploadForm() throws IllegalStateException
    Form used to specify file to upload, and any additional fields required.

    This component is an AutoChild named "uploadForm". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current uploadForm value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setUploadFormFields

    public BatchUploader setUploadFormFields(FormItem... uploadFormFields) throws IllegalStateException
    Optional fields for the uploadForm.
    Parameters:
      `uploadFormFields` - New uploadFormFields value. Default value is null
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getUploadFormFields

    public FormItem[] getUploadFormFields()
    Optional fields for the uploadForm.
    Returns:
      Current uploadFormFields value. Default value is null

  - ### setUploadOperation

    public BatchUploader setUploadOperation(String uploadOperation) throws IllegalStateException
    Optional `DSRequest.operationId` for the "add" operation used to add new records to the `uploadDataSource`.
    Parameters:
      `uploadOperation` - New uploadOperation value. Default value is null
    Returns:
      `BatchUploader` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getUploadOperation

    public String getUploadOperation()
    Optional `DSRequest.operationId` for the "add" operation used to add new records to the `uploadDataSource`.
    Returns:
      Current uploadOperation value. Default value is null

  - ### setUploadQuoteString

    public BatchUploader setUploadQuoteString(String uploadQuoteString)
    The character used to quote strings. The default is double quotes.
    Parameters:
      `uploadQuoteString` - New uploadQuoteString value. Default value is "\""
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getUploadQuoteString

    public String getUploadQuoteString()
    The character used to quote strings. The default is double quotes.
    Returns:
      Current uploadQuoteString value. Default value is "\""

  - ### getUploadStatusMessages

    public HTMLFlow getUploadStatusMessages() throws IllegalStateException
    Container for informational messages that are shown when a user attempts an upload. Appears above the `grid`.

    This component is an AutoChild named "uploadStatusMessages". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current uploadStatusMessages value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setWarnOnCancel

    public BatchUploader setWarnOnCancel(Boolean warnOnCancel)
    If set, indicates that a warning dialog should be shown when Cancel is clicked, asking the user to confirm that this is really what they want to do. The actual warning message is specified with `cancelConfirmMessage`
    Parameters:
      `warnOnCancel` - New warnOnCancel value. Default value is true
    Returns:
      `BatchUploader` instance, for chaining setter calls

  - ### getWarnOnCancel

    public Boolean getWarnOnCancel()
    If set, indicates that a warning dialog should be shown when Cancel is clicked, asking the user to confirm that this is really what they want to do. The actual warning message is specified with `cancelConfirmMessage`
    Returns:
      Current warnOnCancel value. Default value is true

  - ### addBeforeCommitHandler

    public HandlerRegistration addBeforeCommitHandler(BeforeCommitHandler handler)
    Add a beforeCommit handler.

    Notification method fired when the `BatchUploader.commitButton` is clicked.

    This notification occurs before actually committing data to the server. It allows to make changes to the data after user edits, but before it will be sent to server.

    Read also `BatchUploader.previewShown()` docs for details how to change data in grid and for possibility to interrupt upload process on the server as well.

    Specified by:
      `addBeforeCommitHandler` in interface `HasBeforeCommitHandlers`
    Parameters:
      `handler` - the beforeCommit handler
    Returns:
      `HandlerRegistration` used to remove this handler

  - ### addPreviewShownHandler

    public HandlerRegistration addPreviewShownHandler(PreviewShownHandler handler)
    Add a previewShown handler.

    Notification method fired when the `BatchUploader.grid` is populated with a new set of data for the user to preview before commit.

    This notification occurs after the user has uploaded a new data file, the data has been processed on the server, and the preview grid populated with the data ready for committing. Developers may use this notification to examine or modify the data set to be uploaded. The `ListGrid.data` object will be populated with the array of uploaded records, and standard grid APIs such as `ListGrid.getRowErrors()`, `ListGrid.setEditValue()`, etc may be used to interact with this data.

    Note that developers wishing to manipulate the uploaded data can also do this on the server side when user hits the commit button to submit the data to the `BatchUploader.uploadDataSource`. This can be achieved by setting the `BatchUploader.uploadOperation` to call a custom `"add" type operation` on the target dataSource.

    Specified by:
      `addPreviewShownHandler` in interface `HasPreviewShownHandlers`
    Parameters:
      `handler` - the previewShown handler
    Returns:
      `HandlerRegistration` used to remove this handler

  - ### uploadData

    public void uploadData(String data)
    This method assumes a developer has sample data in memory (for example a csv-formatted string), and invokes the dataSource upload operation directly, bypassing the uploadForm.

    The sample data will be available on the server via `values.pasteData`. This usage is expected and understood by the server side batchUpload dataSource.

    This method is most commonly used in conjunction with `showUploadForm:false`.

    Parameters:
      `data` - formatted data to upload

  - ### setDefaultProperties

    public static void setDefaultProperties(BatchUploader batchUploaderProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `batchUploaderProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### setUploadFormItems

    public void setUploadFormItems(FormItem... items) throws IllegalStateException
    Synonym of `setUploadFormFields(FormItem...)`.
    Throws:
      `IllegalStateException`

  - ### setLogicalStructure

    public LogicalStructureObject setLogicalStructure(BatchUploaderLogicalStructure s)
    Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

  - ### getLogicalStructure

    public LogicalStructureObject getLogicalStructure()
    Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    Specified by:
      `getLogicalStructure` in interface `LogicalStructure`
    Overrides:
      `getLogicalStructure` in class `VStack`